import activities.activity_segmentation as segmentation
import activities.activity_clean_eeg as clean_eeg
import activities.activity_adaptive_analysis as adaptive
import activities.activity_machine_learning as machine_learning
import activities.activity_optimal_classification as optimal_classification
import activities.activity_feature_optimization as feature_optimization
import activities.activity_visualization as visualization
import activities.activity_plot_hilbert_spectra as plot_hilbert_spectra

if __name__ == '__main__':

    # -----------------------------PROCEDURE FROM SEGMENTATION TO CLASSIFICATION-------------------------------------- #
    # * 1) First run 'segmentation.start()', which uses EMD as a filter-method to get rid of line noise.               #
    # * 2) Then run 'clean_eeg.start()', which checks for bad trials and stores bad trials for specific electrodes in  #
    #      a boolean matrix.                                                                                           #
    # * 3) Then run 'adaptive.start()', to obtain instantaneous frequencies and amplitude by applying the              #
    #      normalized Hilbert-Huang transform (EMD + Normalization + Hilbert transform)                                #
    # * 4) For a classification with optimization of features (ERD duration and onset), run                            #
    #      'feature_optimization.start()'                                                                              #
    # ---------------------------------------------------------------------------------------------------------------- #

    # Specify subject username (must match the name of the folder inside 'Experiments->EGINet')
    username = 'fredrik'
    segmentation.start(username=username)
    # clean_eeg.start(username=username)
    # adaptive.start(username=username)
    # feature_optimization.start(username=username)
    # ---------------------------------------------------------------------------------------------------------------- #

    # ---------------------------------------------------------------------------------------------------------------- #
    # For visualization and other computations not related to the classification scheme:

    # plot_hilbert_spectra.start(username=username)
    # visualization.start(username=username)

    # ---------------------------------------------------------------------------------------------------------------- #
